QT += core gui concurrent testlib
QT += dbus
QT += gui-private widgets-private

greaterThan(QT_MAJOR_VERSION, 4): QT += widgets

TARGET = test-deepin-phone-master
TEMPLATE = app
CONFIG += c++11 link_pkgconfig
PKGCONFIG += dtkwidget gio-unix-2.0 gio-qt udisks2-qt5 taglib


CONFIG += create_pc create_prl no_install_prl

#include(src.pri)

QMAKE_PKGCONFIG_LIBDIR = $$target.path
QMAKE_PKGCONFIG_VERSION = $$VERSION
QMAKE_PKGCONFIG_DESTDIR = pkgconfig
QMAKE_PKGCONFIG_NAME = deepin-phone-master
QMAKE_PKGCONFIG_DESCRIPTION = Deepin Font Manager Header Files
QMAKE_PKGCONFIG_INCDIR = $$includes.path

includes.path = $$INCLUDE_INSTALL_DIR/deepin-phone-master
includes.files += $$PWD/*.h

isEmpty(PREFIX) {
    PREFIX = /usr
}

isEmpty(LIB_INSTALL_DIR) {
    target.path = $$[QT_INSTALL_LIBS]
} else {
    target.path = $$LIB_INSTALL_DIR
}

isEmpty(INCLUDE_INSTALL_DIR) {
    includes.path = $$PREFIX/include/phoneassistant
} else {
    includes.path = $$INCLUDE_INSTALL_DIR/deepin-phone-master
}

QMAKE_CXXFLAGS += -g -Wall -fprofile-arcs -ftest-coverage -O0
QMAKE_LFLAGS += -g -Wall -fprofile-arcs -ftest-coverage  -O0

include(../third-party/googletest/gtest_dependency.pri)
include(tests/test.pri)

LIBS +=  \
#        -lffmpegthumbnailer \
        -lavcodec \
        -lavdevice \
        -lavfilter \
        -lavformat \
        -lavutil \
#        -lpostproc \
        -lswresample \
        -lswscale \
        -ltag


LIBS += -L$$/usr/lib/ -lPhoneMasterUtil

INCLUDEPATH += $$PWD/../BasicService/Util
DEPENDPATH += $$PWD/../BasicService/Util

LIBS += -L$$/usr/lib/ -lPhoneMasterWidgetService

INCLUDEPATH += $$PWD/../UIService/WidgetService
DEPENDPATH += $$PWD/../UIService/WidgetService

#LIBS += -L$$/usr/lib/ -lPhoneMasterphoneui

#INCLUDEPATH += $$PWD/../UIService/phoneui
#DEPENDPATH += $$PWD/../UIService/phoneui


LIBS += -L$$OUT_PWD/../BasicService/Model/ -lPhoneMasterModel

INCLUDEPATH += $$PWD/../BasicService/Model
DEPENDPATH += $$PWD/../BasicService/Model

LIBS += -L$$OUT_PWD/../BasicService/TranslationService/ -lPhoneMasterTranslationService

INCLUDEPATH += $$PWD/../BasicService/TranslationService
DEPENDPATH += $$PWD/../BasicService/TranslationService

LIBS += -L$$OUT_PWD/../BasicService/Util/ -lPhoneMasterUtil

INCLUDEPATH += $$PWD/../BasicService/Util
DEPENDPATH += $$PWD/../BasicService/Util

LIBS += -L$$OUT_PWD/../MountService/ -lPhoneMasterMountService

INCLUDEPATH += $$PWD/../MountService
DEPENDPATH += $$PWD/../MountService

LIBS += -L$$OUT_PWD/../ThreadService/ -lPhoneMasterThreadService

INCLUDEPATH += $$PWD/../ThreadService
DEPENDPATH += $$PWD/../ThreadService

LIBS += -L$$OUT_PWD/../WidgetService/ -lPhoneMasterWidgetService

INCLUDEPATH += $$PWD/../WidgetService
DEPENDPATH += $$PWD/../WidgetService


